<?php

/**
 * consol_dependencia actions.
 *
 * @package    controlComisiones
 * @subpackage consol_dependencia
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class consol_dependenciaActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.codigo ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];


            /*
             * Variables opcionales
             */
            //Caja Menor
            if (isset($request['id_proyecto'])) {
                $whereCajaMenor = " AND tab0.id_proyecto = " . $request['id_proyecto'];
            } else {
                $whereCajaMenor = ' ';
            }
            //area
            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_area = " . $request['id_area'];
            } else {
                $whereArea = ' ';
            }
            //estado - true por 1 y false por 0
            if (isset($request['estado'])) {
                if ($request['estado'] == 'true') {
                    //Si es true
                    $estado = 1;
                    $whereEstado = " AND tab0.estado = 1 ";
                } elseif ($request['estado'] == '0') {
                    //Si es 0
                    $estado = 0;
                    $whereEstado = " AND tab0.estado = 0 ";
                } else {
                    //Si es false
                    $estado = 0;
                    $whereEstado = " ";
                }
            }






            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            //20170607 se cambia la fecha del filtro de fecha_de resolucion a fecha_inicio(tabla com_comision) asi como la tomada en cuenta en la consulta
            $sql = <<<EOD
select count(*) as count from (

select 

tab0.id_anhos,
tab0.dependencia,
tab0.codigo,
tab0.id_area,
sum(nvl(enero,0)) as enero,
sum(nvl(febrero,0)) as febrero,
sum(nvl(marzo,0)) as marzo,
sum(nvl(abril,0)) as abril,
sum(nvl(mayo,0)) as mayo,
sum(nvl(junio,0)) as junio,
sum(nvl(julio,0)) as julio,
sum(nvl(agosto,0)) as agosto,
sum(nvl(septiembre,0)) as septiembre,
sum(nvl(octubre,0)) as octubre,
sum(nvl(noviembre,0)) as noviembre,
sum(nvl(diciembre,0)) as diciembre,
sum(nvl(total,0)) as total

from(

    select 
    tab0.id_anhos,
    tab3.id_proyecto,
    tab0.estado,
    tab5.id_area,
    tab5.descripcion as dependencia,
    tab5.codigo,
    case when to_char(tab3.fecha_inicio,'mm') = '01' then round(tab0.valor_neto)  else 0 end as enero,
    case when to_char(tab3.fecha_inicio,'mm') = '02' then round(tab0.valor_neto)  else 0 end as febrero,
    case when to_char(tab3.fecha_inicio,'mm') = '03' then round(tab0.valor_neto)  else 0 end as marzo,
    case when to_char(tab3.fecha_inicio,'mm') = '04' then round(tab0.valor_neto)  else 0 end as abril,
    case when to_char(tab3.fecha_inicio,'mm') = '05' then round(tab0.valor_neto)  else 0 end as mayo,
    case when to_char(tab3.fecha_inicio,'mm') = '06' then round(tab0.valor_neto)  else 0 end as junio,
    case when to_char(tab3.fecha_inicio,'mm') = '07' then round(tab0.valor_neto)  else 0 end as julio,
    case when to_char(tab3.fecha_inicio,'mm') = '08' then round(tab0.valor_neto)  else 0 end as agosto,
    case when to_char(tab3.fecha_inicio,'mm') = '09' then round(tab0.valor_neto)  else 0 end as septiembre,
    case when to_char(tab3.fecha_inicio,'mm') = '10' then round(tab0.valor_neto)  else 0 end as octubre,
    case when to_char(tab3.fecha_inicio,'mm') = '11' then round(tab0.valor_neto)  else 0 end as noviembre,
    case when to_char(tab3.fecha_inicio,'mm') = '12' then round(tab0.valor_neto)  else 0 end as diciembre,
    tab0.valor_neto as total
    
    from com_pago_egreso tab0
    join com_cuenta tab1 on tab1.id_cuenta = tab0.id_cuenta
    join com_resolucion tab2 on tab2.id_resolucion = tab1.id_resolucion
    join com_comision tab3 on tab3.id_comision = tab2.id_comision
    left join com_tercero tab4 on tab4.id_tercero = tab1.id_tercero
    left join area tab5 on tab5.id_area = tab3.id_area

    where
    tab3.fecha_inicio between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )
                    
)tab0

where 
tab0.id_anhos = $id_anhos                     
$whereCajaMenor $whereArea    
$whereEstado     

group by 
tab0.id_anhos, 
tab0.dependencia, 
tab0.codigo,
tab0.id_area

) 
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            //20170607 se cambia la fecha del filtro de fecha_de resolucion a fecha_inicio(tabla com_comision) 
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 

tab0.id_anhos,
tab0.dependencia,
tab0.codigo,
tab0.id_area,
sum(nvl(enero,0)) as enero,
sum(nvl(febrero,0)) as febrero,
sum(nvl(marzo,0)) as marzo,
sum(nvl(abril,0)) as abril,
sum(nvl(mayo,0)) as mayo,
sum(nvl(junio,0)) as junio,
sum(nvl(julio,0)) as julio,
sum(nvl(agosto,0)) as agosto,
sum(nvl(septiembre,0)) as septiembre,
sum(nvl(octubre,0)) as octubre,
sum(nvl(noviembre,0)) as noviembre,
sum(nvl(diciembre,0)) as diciembre,
sum(nvl(total,0)) as total

from(

    select 
    tab0.id_anhos,
    tab3.id_proyecto,
    tab0.estado,
    tab5.id_area,
    tab5.descripcion as dependencia,
    tab5.codigo,
    case when to_char(tab3.fecha_inicio,'mm') = '01' then round(tab0.valor_neto)  else 0 end as enero,
    case when to_char(tab3.fecha_inicio,'mm') = '02' then round(tab0.valor_neto)  else 0 end as febrero,
    case when to_char(tab3.fecha_inicio,'mm') = '03' then round(tab0.valor_neto)  else 0 end as marzo,
    case when to_char(tab3.fecha_inicio,'mm') = '04' then round(tab0.valor_neto)  else 0 end as abril,
    case when to_char(tab3.fecha_inicio,'mm') = '05' then round(tab0.valor_neto)  else 0 end as mayo,
    case when to_char(tab3.fecha_inicio,'mm') = '06' then round(tab0.valor_neto)  else 0 end as junio,
    case when to_char(tab3.fecha_inicio,'mm') = '07' then round(tab0.valor_neto)  else 0 end as julio,
    case when to_char(tab3.fecha_inicio,'mm') = '08' then round(tab0.valor_neto)  else 0 end as agosto,
    case when to_char(tab3.fecha_inicio,'mm') = '09' then round(tab0.valor_neto)  else 0 end as septiembre,
    case when to_char(tab3.fecha_inicio,'mm') = '10' then round(tab0.valor_neto)  else 0 end as octubre,
    case when to_char(tab3.fecha_inicio,'mm') = '11' then round(tab0.valor_neto)  else 0 end as noviembre,
    case when to_char(tab3.fecha_inicio,'mm') = '12' then round(tab0.valor_neto)  else 0 end as diciembre,
    tab0.valor_neto as total
    
    from com_pago_egreso tab0
    join com_cuenta tab1 on tab1.id_cuenta = tab0.id_cuenta
    join com_resolucion tab2 on tab2.id_resolucion = tab1.id_resolucion
    join com_comision tab3 on tab3.id_comision = tab2.id_comision
    left join com_tercero tab4 on tab4.id_tercero = tab1.id_tercero
    left join area tab5 on tab5.id_area = tab3.id_area

    where
    tab3.fecha_inicio between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )
                    
)tab0

where 
tab0.id_anhos = $id_anhos                     
$whereCajaMenor $whereArea     
$whereEstado               

group by 
tab0.id_anhos, 
tab0.dependencia, 
tab0.codigo,
tab0.id_area

$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[consol_dependencia] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.codigo ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];


            //Caja Menor
            if (isset($request['id_proyecto'])) {
                $whereCajaMenor = " AND tab0.id_proyecto = " . $request['id_proyecto'];
            } else {
                $whereCajaMenor = ' ';
            }
            //area
            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_area = " . $request['id_area'];
            } else {
                $whereArea = ' ';
            }


            /*
             * Variables opcionales
             */


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

'TOTALES: ' as dependencia,
sum(nvl(enero,0)) as enero,
sum(nvl(febrero,0)) as febrero,
sum(nvl(marzo,0)) as marzo,
sum(nvl(abril,0)) as abril,
sum(nvl(mayo,0)) as mayo,
sum(nvl(junio,0)) as junio,
sum(nvl(julio,0)) as julio,
sum(nvl(agosto,0)) as agosto,
sum(nvl(septiembre,0)) as septiembre,
sum(nvl(octubre,0)) as octubre,
sum(nvl(noviembre,0)) as noviembre,
sum(nvl(diciembre,0)) as diciembre,
sum(nvl(total,0)) as total

FROM (   

select 

tab0.id_anhos,
tab0.dependencia,
tab0.codigo,
tab0.id_area,
sum(nvl(enero,0)) as enero,
sum(nvl(febrero,0)) as febrero,
sum(nvl(marzo,0)) as marzo,
sum(nvl(abril,0)) as abril,
sum(nvl(mayo,0)) as mayo,
sum(nvl(junio,0)) as junio,
sum(nvl(julio,0)) as julio,
sum(nvl(agosto,0)) as agosto,
sum(nvl(septiembre,0)) as septiembre,
sum(nvl(octubre,0)) as octubre,
sum(nvl(noviembre,0)) as noviembre,
sum(nvl(diciembre,0)) as diciembre,
sum(nvl(total,0)) as total

from(

    select 
    tab0.id_anhos,
    tab3.id_proyecto,
    tab0.estado,
    tab5.id_area,
    tab5.descripcion as dependencia,
    tab5.codigo,
    case when to_char(tab3.fecha_inicio,'mm') = '01' then round(tab0.valor_neto)  else 0 end as enero,
    case when to_char(tab3.fecha_inicio,'mm') = '02' then round(tab0.valor_neto)  else 0 end as febrero,
    case when to_char(tab3.fecha_inicio,'mm') = '03' then round(tab0.valor_neto)  else 0 end as marzo,
    case when to_char(tab3.fecha_inicio,'mm') = '04' then round(tab0.valor_neto)  else 0 end as abril,
    case when to_char(tab3.fecha_inicio,'mm') = '05' then round(tab0.valor_neto)  else 0 end as mayo,
    case when to_char(tab3.fecha_inicio,'mm') = '06' then round(tab0.valor_neto)  else 0 end as junio,
    case when to_char(tab3.fecha_inicio,'mm') = '07' then round(tab0.valor_neto)  else 0 end as julio,
    case when to_char(tab3.fecha_inicio,'mm') = '08' then round(tab0.valor_neto)  else 0 end as agosto,
    case when to_char(tab3.fecha_inicio,'mm') = '09' then round(tab0.valor_neto)  else 0 end as septiembre,
    case when to_char(tab3.fecha_inicio,'mm') = '10' then round(tab0.valor_neto)  else 0 end as octubre,
    case when to_char(tab3.fecha_inicio,'mm') = '11' then round(tab0.valor_neto)  else 0 end as noviembre,
    case when to_char(tab3.fecha_inicio,'mm') = '12' then round(tab0.valor_neto)  else 0 end as diciembre,
    tab0.valor_neto as total
    
    from com_pago_egreso tab0
    join com_cuenta tab1 on tab1.id_cuenta = tab0.id_cuenta
    join com_resolucion tab2 on tab2.id_resolucion = tab1.id_resolucion
    join com_comision tab3 on tab3.id_comision = tab2.id_comision
    left join com_tercero tab4 on tab4.id_tercero = tab1.id_tercero
    left join area tab5 on tab5.id_area = tab3.id_area

    where
    tab3.fecha_inicio between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )
                    
)tab0

where 
tab0.id_anhos = $id_anhos                     
$whereCajaMenor $whereArea                   

group by 
tab0.id_anhos, 
tab0.dependencia, 
tab0.codigo,
tab0.id_area

) 
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
